package Dados;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.Hashtable;
import java.util.Timer;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import Pacotes.PacoteDados;

public class DadosCliente {
	
	public static int totalPacotes;

	public static InetAddress ip;
	public static int porta;             
	public static DatagramSocket socket;  

	public static BufferedInputStream streamDados;
	public static Lock mutex;

	public static Hashtable<Integer,PacoteDados> bufferPacotes;
	public static LinkedBlockingQueue<Integer> bufferAcks; 

	public static int proxNum;         // numero de sequencia do proximo pacote
	public static int base;          
	public static int janela;        
	public static int timeoutPacote;  // tempo para reenviar pacote
	public static int timeoutSocket; // tempo para encerrar conexoaps o envio do pacote fim

	public static Timer timeoutTimer;

	public static void inicializar() throws Exception{

		DadosCliente.socket = new DatagramSocket();
		DadosCliente.ip = InetAddress.getByName("localhost"); // IP do Servidor
		DadosCliente.porta = 5000;
		
		File file = new File("teste");
		DadosCliente.totalPacotes = (int)Math.ceil((double)file.length()/PacoteDados.tamanhoDados);
		DadosCliente.streamDados = new BufferedInputStream(new FileInputStream(file));

		DadosCliente.bufferPacotes = new Hashtable<Integer,PacoteDados>();
		DadosCliente.bufferAcks = new LinkedBlockingQueue<Integer>(); 

		DadosCliente.proxNum = 0;
		DadosCliente.base = 0;
		DadosCliente.janela = 50;

		DadosCliente.timeoutPacote = 1000;
		DadosCliente.timeoutSocket = 5000;
		DadosCliente.timeoutTimer = new Timer(true); 
		DadosCliente.mutex = new ReentrantLock();

	}

	
}
