package ClienteServidor;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import Dados.*;
import Threads.EnviarDados;
import Threads.EsperarAcks;


public class Cliente {
	public static void main(String args[]) throws Exception {
		
		DadosCliente.inicializar(); // inicializa dados do cliente
		System.out.println("Tamanho do arquivo: " + DadosCliente.streamDados.available() + " bytes");
		System.out.println("Enviando arquivo...");
		System.out.println();
		 
		//criando threads
		EnviarDados enviar = new EnviarDados();
		EsperarAcks espera = new EsperarAcks(enviar);
		ExecutorService threads = Executors.newCachedThreadPool();
		threads.execute(enviar);
		threads.execute(espera);

		
	}
}
